{******************************************************************}
{ part of DSPack 1.05                                                     }
{                                                                  }
{ home page : http://www.progdigy.com                              }
{ email     : hgourvest@progdigy.com                               }
{                                                                  }
{ date      : 20-11-2001                                           }
{                                                                  }
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or   }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{ *****************************************************************}

unit DSEditors;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DirectShow, DSPack, DSUtil, DSFilters, DesignEditors,
  DesignIntf, FilterSelector;

type

  TFilterPropertyClass = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TFilterCompoEditor = class(TDefaultEditor)
  protected
    procedure EditProperty(const Prop: IProperty; var Continue: Boolean); override;
  end;

  procedure Register;

implementation

procedure TFilterPropertyClass.Edit;
var
  Dlg: TFilterSelectorForm;
begin
  Application.CreateForm(TFilterSelectorForm, Dlg);
  try
      with GetComponent(0) as TFilter do
      begin
        Dlg.FilterName   := Filter.FilterName;
        Dlg.CategoryName := Filter.CategoryName;
      end;
    if Dlg.ShowModal = mrOk then
    begin
      with GetComponent(0) as TFilter do
      begin
        Filter.Moniker      := Dlg.Moniker;
        Filter.FilterName   := Dlg.FilterName;
        Filter.CategoryName := Dlg.CategoryName;
        Filter.FilterGUID   := GUIDToString(Dlg.FilterGUID);
        Filter.CategoryGUID := GUIDToString(Dlg.CategoryGUID);
      end;
      Modified;
    end;
  finally
    Dlg.Free;
  end;
end;

function TFilterPropertyClass.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

// ------------------------

  procedure TFilterCompoEditor.EditProperty(const Prop: IProperty; var Continue: Boolean);
  var
    Dlg: TFilterSelectorForm;
  begin
    if ((Component.ClassName = 'TFilter') and  (prop.GetName = 'Filter')) then
    begin
      Application.CreateForm(TFilterSelectorForm, Dlg);
      try
          with Component as TFilter do
          begin
            Dlg.FilterName   := Filter.FilterName;
            Dlg.CategoryName := Filter.CategoryName;
          end;
        if Dlg.ShowModal = mrOk then
        begin
          with Component as TFilter do
          begin
            Filter.Moniker      := Dlg.Moniker;
            Filter.FilterName   := Dlg.FilterName;
            Filter.CategoryName := Dlg.CategoryName;
            Filter.FilterGUID   := GUIDToString(Dlg.FilterGUID);
            Filter.CategoryGUID := GUIDToString(Dlg.CategoryGUID);
          end;
          GetDesigner.Modified;
        end;
      finally
        Dlg.Free;
      end;
    end;
  end;

// ------------------------

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TFilterProp), nil, '', TFilterPropertyClass);
  RegisterComponentEditor(TFilter, TFilterCompoEditor);
end;

end.
